import { IInterestRateContractWithStatus } from '@jdxconsulting/cdm-model';
import { IBNOMember } from '@jdxconsulting/cdm-members-common/lib/cdm-bno/model/bnoMember';
import { ITradeListDragDropState } from './tradeList';
export interface ITradeDropZoneProps {
    trades: IInterestRateContractWithStatus[];
    currentMember: IBNOMember;
    process: ITradeDropZoneResponseProps;
    peerCount: number;
    dragDropState: ITradeListDragDropState;
}
export interface ITradeDropZoneResponseProps {
    dropZoneContext: TradeDropZoneType;
    immediateAction: boolean;
    flagCallback: TTradeFlagCallback;
    actCallback: TTradeActionCallback;
}
export declare enum TradeDropZoneType {
    Compress = 0,
    Affirm = 1,
    Reject = 2,
    Clear = 3
}
export declare type TTradeFlagCallback = (t: IInterestRateContractWithStatus) => void;
export declare type TTradeActionCallback = (m: IBNOMember) => void;
export declare const TradeDropZone: (props: ITradeDropZoneProps) => any;
