import * as React from 'react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { SelectedTrades } from './selectedTrades';
export var TradeDropZoneType;
(function (TradeDropZoneType) {
    TradeDropZoneType[TradeDropZoneType["Compress"] = 0] = "Compress";
    TradeDropZoneType[TradeDropZoneType["Affirm"] = 1] = "Affirm";
    TradeDropZoneType[TradeDropZoneType["Reject"] = 2] = "Reject";
    TradeDropZoneType[TradeDropZoneType["Clear"] = 3] = "Clear";
})(TradeDropZoneType || (TradeDropZoneType = {}));
export var TradeDropZone = function (props) {
    return (React.createElement("div", { className: props.peerCount === 4 ? "col-sm-3" : (props.peerCount === 3 ? "col-sm-4" : (props.peerCount === 2 ? "col-sm-6" : "col-sm-12")) },
        React.createElement("div", { className: "card" },
            React.createElement("h5", { className: "card-header" },
                props.process.dropZoneContext === TradeDropZoneType.Compress ? "Compress" : props.process.dropZoneContext === TradeDropZoneType.Affirm ? "Affirm" : props.process.dropZoneContext === TradeDropZoneType.Reject ? "Reject" : "Clear",
                " Trades",
                props.process.immediateAction === false ?
                    React.createElement("button", { type: "button", title: props.process.dropZoneContext === TradeDropZoneType.Compress ? "Compress" : props.process.dropZoneContext === TradeDropZoneType.Affirm ? "Affirm" : props.process.dropZoneContext === TradeDropZoneType.Reject ? "Reject" : "Clear" + " selected trade(s).", className: "btn btn-info float-right", onClick: function () { return props.process.actCallback(props.currentMember); } },
                        React.createElement(FontAwesomeIcon, { icon: "angle-double-down" }))
                    : React.createElement("div", null)),
            React.createElement("div", { className: "card-body", onDragOver: function (ev) { return ev.preventDefault(); }, onDrop: function (ev) {
                    ev.preventDefault();
                    if (props.dragDropState.SelectedTrade &&
                        ((props.process.dropZoneContext === TradeDropZoneType.Compress && props.dragDropState.CanCompress) ||
                            (props.process.dropZoneContext === TradeDropZoneType.Affirm && props.dragDropState.CanAffirm) ||
                            (props.process.dropZoneContext === TradeDropZoneType.Reject && props.dragDropState.CanReject) ||
                            (props.process.dropZoneContext === TradeDropZoneType.Clear && props.dragDropState.CanClear))) {
                        console.log("#DRAGDROP# - " + (props.process.dropZoneContext === TradeDropZoneType.Compress ? "Compress" : props.process.dropZoneContext === TradeDropZoneType.Affirm ? "Affirm" : props.process.dropZoneContext === TradeDropZoneType.Reject ? "Reject" : "Clear") + ": Dropped " + props.dragDropState.SelectedTrade.cdmContract.contractIdentifier[0].identifierValue.identifier);
                        props.process.flagCallback(props.dragDropState.SelectedTrade);
                        if (props.process.immediateAction === true) {
                            props.process.actCallback(props.currentMember);
                        }
                    }
                    if (ev.target.className === "card-body bg-success") {
                        ev.target.className = "card-body";
                    }
                }, onDragEnter: function (ev) {
                    ev.preventDefault();
                    if (props.dragDropState.SelectedTrade &&
                        ((props.process.dropZoneContext === TradeDropZoneType.Compress && props.dragDropState.CanCompress) ||
                            (props.process.dropZoneContext === TradeDropZoneType.Affirm && props.dragDropState.CanAffirm) ||
                            (props.process.dropZoneContext === TradeDropZoneType.Reject && props.dragDropState.CanReject) ||
                            (props.process.dropZoneContext === TradeDropZoneType.Clear && props.dragDropState.CanClear))) {
                        if (ev.target.className === "card-body") {
                            ev.target.className = "card-body bg-success";
                        }
                    }
                }, onDragLeave: function (e) {
                    e.preventDefault();
                    if (e.target.className === "card-body bg-success") {
                        e.target.className = "card-body";
                    }
                } }, props.process.immediateAction === true ?
                React.createElement("div", { className: "container-fluid" },
                    React.createElement(FontAwesomeIcon, { icon: "map-pin" }),
                    " Drop Trades Here") :
                React.createElement(SelectedTrades, { selectTradeCallback: props.process.flagCallback, selectedTrades: props.trades.filter(function (t) { return t.selectedForCompress === true; }) })))));
};
//# sourceMappingURL=tradeDropZone.js.map