var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from "react";
import { InterestRateContractTemplate } from '@jdxconsulting/cdm-model';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
var TradeEntry = /** @class */ (function (_super) {
    __extends(TradeEntry, _super);
    function TradeEntry(props) {
        var _this = _super.call(this, props) || this;
        _this.render = function () {
            return (React.createElement("div", null,
                React.createElement("h1", null, "Trade Entry"),
                React.createElement("table", { className: "table table-striped table-hover" },
                    React.createElement("thead", null,
                        React.createElement("tr", null,
                            React.createElement("th", null, "Originator"),
                            React.createElement("th", null, "Facing"),
                            React.createElement("th", null, "CCY"),
                            React.createElement("th", null, "Value"),
                            React.createElement("th", null, "Payment Period"),
                            React.createElement("th", null))),
                    React.createElement("tbody", null,
                        React.createElement("tr", null,
                            React.createElement("td", null, _this.props.originator.state.data.membershipMetadata.name),
                            React.createElement("td", null,
                                React.createElement("select", { className: "custom-select", onLoad: _this.facingChanged, onChange: _this.facingChanged }, _this.props.facingOptions.filter(function (m) {
                                    return m.state.data.membershipMetadata.name.toUpperCase() !== "BNO" &&
                                        m.state.data.membershipMetadata.role.toUpperCase() !== "ORACLE" &&
                                        m.state.data.membershipMetadata.role.toUpperCase() !== "CCP" &&
                                        m.state.data.membershipMetadata.role.toUpperCase() !== "REGULATOR" &&
                                        m.state.data.membershipMetadata.legalEntityId !== _this.props.originator.state.data.membershipMetadata.legalEntityId;
                                }).map(function (fo) {
                                    return React.createElement("option", { value: fo.state.data.membershipMetadata.legalEntityId, key: fo.state.data.membershipMetadata.legalEntityId }, fo.state.data.membershipMetadata.name);
                                }))),
                            React.createElement("td", null,
                                React.createElement("select", { className: "custom-select", onChange: _this.ccyChanged },
                                    React.createElement("option", { value: "USD", key: "USD" }, "USD"),
                                    React.createElement("option", { value: "GBP", key: "GBP" }, "GBP"),
                                    React.createElement("option", { value: "EUR", key: "EUR" }, "EUR"))),
                            React.createElement("td", null,
                                React.createElement("input", { type: "text", name: "tradeValue", defaultValue: "100000", onChange: _this.initialValueChanged })),
                            React.createElement("td", null,
                                React.createElement("select", { className: "custom-select", onChange: _this.periodChanged },
                                    React.createElement("option", { value: "M", key: "M" }, "Monthly"),
                                    React.createElement("option", { value: "W", key: "W" }, "Weekly"),
                                    React.createElement("option", { value: "D", key: "D" }, "Daily"))),
                            React.createElement("td", null,
                                React.createElement("button", { type: "button", className: "btn btn-info", title: "Submit New Trade.", onClick: function () { return _this.props.submitHandler(_this.props.originator.host.hostIP, _this.props.originator.host.hostPort, JSON.stringify(_this.state.tradeContract)); } },
                                    React.createElement(FontAwesomeIcon, { icon: "sign-in-alt" }))))))));
        };
        _this.ccyChanged = function (event) { _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency = event.target.value; };
        _this.periodChanged = function (event) { _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].calculationPeriodDates.calculationPeriodFrequency.period = event.target.value; };
        _this.facingChanged = function (event) { _this.state.tradeContract.account[1].accountNumber = event.target.value; };
        _this.initialValueChanged = function (event) { _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.initialValue = event.target.value; };
        _this.state = { tradeContract: InterestRateContractTemplate };
        _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency = "USD";
        _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.initialValue = 100000;
        _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].calculationPeriodDates.calculationPeriodFrequency.period = "M";
        _this.state.tradeContract.account[0].accountNumber = props.originator.state.data.membershipMetadata.legalEntityId;
        _this.state.tradeContract.account[1].accountNumber = props.facingOptions.filter(function (m) {
            return m.state.data.membershipMetadata.name.toUpperCase() !== "BNO" &&
                m.state.data.membershipMetadata.role.toUpperCase() !== "CCP" &&
                m.state.data.membershipMetadata.legalEntityId !== _this.props.originator.state.data.membershipMetadata.legalEntityId;
        })[0].state.data.membershipMetadata.legalEntityId;
        _this.state.tradeContract.contractIdentifier[0].version = 1;
        _this.state.tradeContract.contractIdentifier[0].identifierValue.identifier = "TradeId_" + new Date().getTime();
        _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference = props.originator.state.data.membershipMetadata.name;
        _this.state.tradeContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference = props.facingOptions.filter(function (m) {
            return m.state.data.membershipMetadata.name.toUpperCase() !== "BNO" &&
                m.state.data.membershipMetadata.role.toUpperCase() !== "CCP" &&
                m.state.data.membershipMetadata.legalEntityId !== _this.props.originator.state.data.membershipMetadata.legalEntityId;
        })[0].state.data.membershipMetadata.name;
        _this.state.tradeContract.tradeDate.adjustableDate.unadjustedDate = new Date().toISOString().split('T')[0];
        return _this;
    }
    return TradeEntry;
}(React.Component));
export { TradeEntry };
//# sourceMappingURL=tradeEntry.js.map