var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from "react";
import Tree from "react-tree-graph";
import "../../../../../src/App.css";
var TradeHistoryModal = /** @class */ (function (_super) {
    __extends(TradeHistoryModal, _super);
    function TradeHistoryModal(props) {
        var _this = _super.call(this, props) || this;
        _this.render = function () {
            var selected = _this.props.trades.filter(function (t) { return t.selectedForLineage === true; })[0];
            return (React.createElement("div", null, selected && _this.props.trades ?
                React.createElement("div", { className: "customModal" },
                    React.createElement("div", { className: "modal-dialog modal-lg" },
                        React.createElement("div", { className: "modal-content" },
                            React.createElement("div", { className: "modal-header" },
                                React.createElement("h2", null, " Trade lineage "),
                                React.createElement("button", { type: "button", className: "close", "aria-label": "Close", onClick: function () {
                                        _this.props.selectForLineageHandler(_this.props.currentMember, selected);
                                    } },
                                    React.createElement("span", { "aria-hidden": "true" }, "\u00D7"))),
                            React.createElement("div", { className: "modal-body" }, selected.cdmContractsLineage &&
                                selected.cdmContractsLineage.length > 0 ?
                                React.createElement("div", null,
                                    React.createElement("div", { className: "container-fluid" },
                                        React.createElement("table", { className: "table table-striped table-hover" },
                                            React.createElement("thead", null,
                                                React.createElement("tr", null,
                                                    React.createElement("th", { scope: "col" }, "Party 1"),
                                                    React.createElement("th", { scope: "col" }, "Party 2"),
                                                    React.createElement("th", { scope: "col" }, "Id"),
                                                    React.createElement("th", null, "Currency"),
                                                    React.createElement("th", null, "Notional"),
                                                    React.createElement("th", null, "Date"),
                                                    React.createElement("th", null, "Asset Class"))),
                                            React.createElement("tbody", null, selected.cdmContractsLineage.map(function (t) {
                                                return React.createElement("tr", { key: t.cdmContract.contractIdentifier[0].identifierValue.identifier },
                                                    React.createElement("td", null,
                                                        React.createElement("div", null, t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference)),
                                                    React.createElement("td", null,
                                                        React.createElement("div", null, t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference)),
                                                    React.createElement("td", null, t.cdmContract.contractIdentifier[0].identifierValue.identifier),
                                                    React.createElement("td", null, t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency),
                                                    React.createElement("td", null, t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.initialValue),
                                                    React.createElement("td", null, t.cdmContract.tradeDate.adjustableDate.unadjustedDate),
                                                    React.createElement("td", null, t.cdmContract.contractualProduct.productIdentification.primaryAssetClass));
                                            })))),
                                    _this.getTree(selected) ?
                                        React.createElement("div", { className: "col-md-6 col-md-offset-3" },
                                            React.createElement("div", { id: "treeWrapper", style: { width: '50em', height: '25em' } },
                                                React.createElement(Tree, { data: _this.getTree(selected), height: 400, width: 700, svgProps: { className: 'custom' }, nodeOffset: -5 })))
                                        :
                                            React.createElement("div", null))
                                :
                                    React.createElement("div", null,
                                        React.createElement("h4", null, "No trade lineage data."),
                                        _this.getTree(selected) ?
                                            React.createElement("div", { className: "col-md-6 col-md-offset-3" },
                                                React.createElement("div", { id: "treeWrapper", style: { width: '50em', height: '25em' } },
                                                    React.createElement(Tree, { data: _this.getTree(selected), height: 400, width: 700, svgProps: { className: 'custom' }, nodeOffset: -5 })))
                                            :
                                                React.createElement("div", null))),
                            React.createElement("div", { className: "modal-footer" },
                                React.createElement("button", { className: "btn btn-secondary", onClick: function () {
                                        _this.props.selectForLineageHandler(_this.props.currentMember, selected);
                                    } }, "Close")))))
                :
                    React.createElement("div", null)));
        };
        _this.getTree = function (t) {
            var root = {
                children: [],
                name: t.cdmContract.contractIdentifier[0].identifierValue.identifier + ' (' + t.contractStatus + ')',
            };
            var getChildren = _this.getChildrenRecursion(t, t);
            if (getChildren && getChildren.length > 0) {
                root.children = getChildren;
            }
            return root;
        };
        _this.getChildrenRecursion = function (parent, t) {
            var childrenList = [];
            if (t.cdmContractsLineage) {
                var _loop_1 = function (contract) {
                    var child = {
                        children: [],
                        name: contract.cdmContract.contractIdentifier[0].identifierValue.identifier,
                    };
                    child.gProps = {
                        className: 'node',
                        onClick: function () {
                            _this.props.selectForLineageHandler(_this.props.currentMember, parent);
                            _this.props.selectForLineageHandler(_this.props.currentMember, contract);
                        }
                    };
                    if (parent.contractStatus !== 'TERMINATED' && parent.contractStatus !== 'NOVATED') {
                        var getChildren = _this.getChildrenRecursion(parent, contract);
                        if (getChildren && getChildren.length > 0) {
                            child.children = getChildren;
                        }
                    }
                    childrenList.push(child);
                };
                for (var _i = 0, _a = t.cdmContractsLineage; _i < _a.length; _i++) {
                    var contract = _a[_i];
                    _loop_1(contract);
                }
            }
            return childrenList;
        };
        return _this;
    }
    TradeHistoryModal.prototype.componentDidUpdate = function (prevProps) {
        var _this = this;
        if (prevProps.trades !== this.props.trades) {
            setTimeout(function () { return _this.forceUpdate(); }, 300);
            setTimeout(function () { return _this.forceUpdate(); }, 500);
            setTimeout(function () { return _this.forceUpdate(); }, 800);
            setTimeout(function () { return _this.forceUpdate(); }, 1500);
            setTimeout(function () { return _this.forceUpdate(); }, 2500);
            setTimeout(function () { return _this.forceUpdate(); }, 5000);
        }
    };
    return TradeHistoryModal;
}(React.Component));
export default TradeHistoryModal;
//# sourceMappingURL=tradeHistoryModal.js.map