import * as React from "react";
import { IInterestRateContractWithStatus } from '@jdxconsulting/cdm-model';
import { IBNOMember } from "@jdxconsulting/cdm-members-common/lib/cdm-bno/model/bnoMember";
import '../../../../../src/App';
import "../../../../../src/App.css";
export declare enum TradeListContextEnum {
    RW = 0,
    RO = 1
}
export interface ITradeListProps {
    trades: IInterestRateContractWithStatus[];
    selectForApproveHandler: any;
    selectForRejectHandler: any;
    selectForClearingHandler: any;
    selectForCompressHandler: any;
    selectForLineageHandler: any;
    actionApproveHandler: any;
    actionRejectHandler: any;
    actionClearHandler: any;
    actionCompressHandler: any;
    context: TradeListContextEnum;
    currentMember: IBNOMember;
}
export interface ITradeListState {
    CurrencyFilters: string[];
    CurrencyFilter: string;
    StatusFilters: string[];
    StatusFilter: string;
    AssetClassFilters: string[];
    AssetClassFilter: string;
    Party1Filters: string[];
    Party1Filter: string;
    Party2Filters: string[];
    Party2Filter: string;
    DragDropState: ITradeListDragDropState;
}
export interface ITradeListDragDropState {
    SelectedTrade?: IInterestRateContractWithStatus;
    CanCompress: boolean;
    CanClear: boolean;
    CanAffirm: boolean;
    CanReject: boolean;
}
export declare class TradeList extends React.Component<ITradeListProps, ITradeListState> {
    constructor(props: ITradeListProps);
    componentDidUpdate: (prevProps: ITradeListProps, prevState: ITradeListState) => void;
    render: () => any;
    private startDraggingTrade;
    private createDragState;
    private clearDragState;
    private tradeDragEnds;
    private tradeManagementColumnCount;
    private showCompressTrades;
    private showAffirmTrades;
    private showClearTrades;
    private ccyFilters;
    private statusFilters;
    private assetClassFilters;
    private party1Filters;
    private party2Filters;
    private ccyFilterChanged;
    private statusFilterChanged;
    private assetClassFilterChanged;
    private party1FilterChanged;
    private party2FilterChanged;
    private filteredTrades;
}
