var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from "react";
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { TradeListFilter } from "./tradeListFilter";
import '../../../../../src/App';
import { CSVLink } from "react-csv";
import jsonexport from 'jsonexport';
import { TradeListItemRow } from "./tradeListItemRow";
import { TradeEligibleForCompression, TradeEligibleForAffirmation, TradeEligibleForRejection, TradeEligibleForClearing } from "../domain/model";
import { TradeDropZone, TradeDropZoneType } from "./tradeDropZone";
import TradeDragImg from '../../../../../src/assets/stock-trading-icon.png';
import TradeHistoryModal from "./tradeHistoryModal";
import "../../../../../src/App.css";
export var TradeListContextEnum;
(function (TradeListContextEnum) {
    TradeListContextEnum[TradeListContextEnum["RW"] = 0] = "RW";
    TradeListContextEnum[TradeListContextEnum["RO"] = 1] = "RO";
})(TradeListContextEnum || (TradeListContextEnum = {}));
var TradeList = /** @class */ (function (_super) {
    __extends(TradeList, _super);
    function TradeList(props) {
        var _this = _super.call(this, props) || this;
        _this.componentDidUpdate = function (prevProps, prevState) {
            console.log("########## LIFECYCLE - COMPONENT DID UPDATE !! ########## " + _this.props.trades.length + " vs (prev) " + prevProps.trades.length);
        };
        _this.render = function () {
            var csvExport;
            jsonexport(_this.props.trades, function (err, csv) {
                if (err) {
                    console.error(err);
                    csvExport = "Error in retriving the data.";
                }
                ;
                csvExport = csv;
            });
            return (React.createElement("div", null,
                React.createElement(TradeHistoryModal, { trades: _this.props.trades, selectForLineageHandler: _this.props.selectForLineageHandler, currentMember: _this.props.currentMember }),
                React.createElement("table", { className: "table table-striped table-hover" },
                    React.createElement("thead", null,
                        React.createElement("tr", null,
                            React.createElement("th", null,
                                React.createElement(TradeListFilter, { ColumnName: "Party 1", SelectedFilter: _this.state.Party1Filter, FilterList: _this.state.Party1Filters, FilterChanged: _this.party1FilterChanged })),
                            React.createElement("th", null,
                                React.createElement(TradeListFilter, { ColumnName: "Party 2", SelectedFilter: _this.state.Party2Filter, FilterList: _this.state.Party2Filters, FilterChanged: _this.party2FilterChanged })),
                            React.createElement("th", null, "Id"),
                            React.createElement("th", null,
                                React.createElement(TradeListFilter, { ColumnName: "Status", SelectedFilter: _this.state.StatusFilter, FilterList: _this.state.StatusFilters, FilterChanged: _this.statusFilterChanged })),
                            React.createElement("th", null,
                                React.createElement(TradeListFilter, { ColumnName: "Currency", SelectedFilter: _this.state.CurrencyFilter, FilterList: _this.state.CurrencyFilters, FilterChanged: _this.ccyFilterChanged })),
                            React.createElement("th", null, "Notional"),
                            React.createElement("th", null, "Date"),
                            React.createElement("th", null, "Calc Date"),
                            React.createElement("th", null, "Calc Freq"),
                            React.createElement("th", null,
                                React.createElement(TradeListFilter, { ColumnName: "Asset Class", SelectedFilter: _this.state.AssetClassFilter, FilterList: _this.state.AssetClassFilters, FilterChanged: _this.assetClassFilterChanged })),
                            React.createElement("th", null))),
                    React.createElement("tbody", null, _this.filteredTrades(_this.props.trades).map(function (t) {
                        return React.createElement(TradeListItemRow, { key: t.cdmContract.contractIdentifier[0].identifierValue.identifier, trade: t, selectForApproveHandler: _this.props.selectForApproveHandler, selectForRejectHandler: _this.props.selectForRejectHandler, selectForClearingHandler: _this.props.selectForClearingHandler, selectForCompressHandler: _this.props.selectForCompressHandler, selectForLineageHandler: _this.props.selectForLineageHandler, dragStartHandler: _this.startDraggingTrade, dragEndHandler: _this.tradeDragEnds, context: _this.props.context, currentMember: _this.props.currentMember });
                    }))),
                React.createElement("div", { className: "row" },
                    _this.showCompressTrades() ?
                        React.createElement(TradeDropZone, { trades: _this.props.trades, currentMember: _this.props.currentMember, process: { dropZoneContext: TradeDropZoneType.Compress, immediateAction: false, flagCallback: _this.props.selectForCompressHandler, actCallback: _this.props.actionCompressHandler }, peerCount: _this.tradeManagementColumnCount(), dragDropState: _this.state.DragDropState })
                        : React.createElement("div", null),
                    _this.showAffirmTrades() ?
                        React.createElement(TradeDropZone, { trades: _this.props.trades, currentMember: _this.props.currentMember, process: { dropZoneContext: TradeDropZoneType.Affirm, immediateAction: true, flagCallback: _this.props.selectForApproveHandler, actCallback: _this.props.actionApproveHandler }, peerCount: _this.tradeManagementColumnCount(), dragDropState: _this.state.DragDropState })
                        : React.createElement("div", null),
                    _this.showAffirmTrades() ?
                        React.createElement(TradeDropZone, { trades: _this.props.trades, currentMember: _this.props.currentMember, process: { dropZoneContext: TradeDropZoneType.Reject, immediateAction: true, flagCallback: _this.props.selectForRejectHandler, actCallback: _this.props.actionRejectHandler }, peerCount: _this.tradeManagementColumnCount(), dragDropState: _this.state.DragDropState })
                        : React.createElement("div", null),
                    _this.showClearTrades() ?
                        React.createElement(TradeDropZone, { trades: _this.props.trades, currentMember: _this.props.currentMember, process: { dropZoneContext: TradeDropZoneType.Clear, immediateAction: true, flagCallback: _this.props.selectForClearingHandler, actCallback: _this.props.actionClearHandler }, peerCount: _this.tradeManagementColumnCount(), dragDropState: _this.state.DragDropState })
                        : React.createElement("div", null)),
                _this.props.trades && _this.props.trades.length > 0 ?
                    React.createElement("div", null,
                        React.createElement("hr", null),
                        React.createElement("div", null,
                            React.createElement(CSVLink, { className: "btn btn-info", data: csvExport, filename: Date.now() + "_Trades_List.csv" },
                                React.createElement(FontAwesomeIcon, { icon: "file-export" }),
                                "Export CSV")))
                    :
                        React.createElement("div", null)));
        };
        // Drag Start
        _this.startDraggingTrade = function (ev, trade) {
            // Capture the trade being dragged. We don't know the desitination yet, so test eligibility for all potential landing zones.
            console.log("#DRAGDROP# - Dragging " + trade.cdmContract.contractIdentifier[0].identifierValue.identifier);
            var image = document.createElement("img");
            image.src = TradeDragImg;
            ev.dataTransfer.setDragImage(image, 0, 0);
            _this.createDragState(trade);
        };
        _this.createDragState = function (trade) {
            console.log("#DRAGDROP# - Setting Drag State.");
            _this.setState(__assign({}, _this.state, { DragDropState: __assign({}, _this.state.DragDropState, { CanAffirm: TradeEligibleForAffirmation(trade, _this.props.currentMember), CanClear: TradeEligibleForClearing(trade), CanCompress: TradeEligibleForCompression(trade, _this.props.trades.filter(function (t) { return t.selectedForCompress; })), CanReject: TradeEligibleForRejection(trade, _this.props.currentMember), SelectedTrade: trade }) }));
        };
        _this.clearDragState = function () {
            console.log("#DRAGDROP# - Clearing Drag State.");
            _this.setState(__assign({}, _this.state, { DragDropState: __assign({}, _this.state.DragDropState, { CanAffirm: false, CanClear: false, CanCompress: false, CanReject: false, SelectedTrade: undefined }) }));
        };
        // Drag End
        _this.tradeDragEnds = function (ev) {
            console.log("#DRAGDROP# - Drag Ends.");
            if (ev.target.className === "card-body bg-success") {
                ev.target.className = "card-body";
            }
            _this.clearDragState();
        };
        _this.tradeManagementColumnCount = function () {
            return (_this.showAffirmTrades() ? 2 : 0) + (_this.showCompressTrades() ? 1 : 0) + (_this.showClearTrades() ? 1 : 0);
        };
        _this.showCompressTrades = function () {
            return _this.props.currentMember.state.data.membershipMetadata.role.toUpperCase() !== "REGULATOR" &&
                _this.props.currentMember.state.data.membershipMetadata.role.toUpperCase() !== "ORACLE" &&
                _this.props.trades && _this.filteredTrades(_this.props.trades).filter(function (t) { return t.contractStatus === "LIVE"; }).length > 0;
        };
        _this.showAffirmTrades = function () {
            return _this.props.currentMember.state.data.membershipMetadata.role.toUpperCase() === "DEALER" &&
                _this.props.trades && _this.filteredTrades(_this.props.trades).filter(function (t) { return t.contractStatus === "DRAFT"; }).length > 0;
        };
        _this.showClearTrades = function () {
            return _this.props.currentMember.state.data.membershipMetadata.role.toUpperCase() === "DEALER" &&
                _this.props.trades && _this.filteredTrades(_this.props.trades).filter(function (t) { return t.contractStatus === "LIVE"; }).length > 0;
        };
        _this.ccyFilters = function () {
            return ["*", "USD", "EUR", "GBP"];
        };
        _this.statusFilters = function () {
            return ["*", "LIVE", "DRAFT", "NOVATED", "TERMINATED", "REJECTED"];
        };
        _this.assetClassFilters = function () {
            return ["*", "INTEREST_RATE"];
        };
        _this.party1Filters = function () {
            return ["*", "DEALER-D01", "DEALER-D02", "DEALER-D03", "CCP-P01"];
        };
        _this.party2Filters = function () {
            return ["*", "DEALER-D01", "DEALER-D02", "DEALER-D03", "CCP-P01"];
        };
        _this.ccyFilterChanged = function (filter) {
            _this.setState(__assign({}, _this.state, { CurrencyFilter: filter }));
        };
        _this.statusFilterChanged = function (filter) {
            _this.setState(__assign({}, _this.state, { StatusFilter: filter }));
        };
        _this.assetClassFilterChanged = function (filter) {
            _this.setState(__assign({}, _this.state, { AssetClassFilter: filter }));
        };
        _this.party1FilterChanged = function (filter) {
            _this.setState(__assign({}, _this.state, { Party1Filter: filter }));
        };
        _this.party2FilterChanged = function (filter) {
            _this.setState(__assign({}, _this.state, { Party2Filter: filter }));
        };
        _this.filteredTrades = function (unfilteredTrades) {
            if (_this.state.AssetClassFilter === "*" &&
                _this.state.CurrencyFilter === "*" &&
                _this.state.Party1Filter === "*" &&
                _this.state.Party2Filter === "*" &&
                _this.state.StatusFilter === "*") {
                return unfilteredTrades.slice();
            }
            var filteredTradesList = unfilteredTrades.slice();
            if (_this.state.AssetClassFilter !== "*") {
                filteredTradesList = filteredTradesList.slice().filter(function (t) { return t.cdmContract.contractualProduct.productIdentification.primaryAssetClass === _this.state.AssetClassFilter; });
            }
            if (_this.state.CurrencyFilter !== "*") {
                filteredTradesList = filteredTradesList.slice().filter(function (t) { return t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency === _this.state.CurrencyFilter; });
            }
            if (_this.state.Party1Filter !== "*") {
                filteredTradesList = filteredTradesList.slice().filter(function (t) { return t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference === _this.state.Party1Filter; });
            }
            if (_this.state.Party2Filter !== "*") {
                filteredTradesList = filteredTradesList.slice().filter(function (t) { return t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference === _this.state.Party2Filter; });
            }
            if (_this.state.StatusFilter !== "*") {
                filteredTradesList = filteredTradesList.slice().filter(function (t) { return t.contractStatus === _this.state.StatusFilter; });
            }
            return filteredTradesList;
        };
        console.log("########## LIFECYCLE - CONSTRUCTOR!! ########## Trade Count: " + props.trades.length);
        _this.state = {
            AssetClassFilter: "*",
            AssetClassFilters: _this.assetClassFilters(),
            CurrencyFilter: "*",
            CurrencyFilters: _this.ccyFilters(),
            Party1Filter: "*",
            Party1Filters: _this.party1Filters(),
            Party2Filter: "*",
            Party2Filters: _this.party2Filters(),
            StatusFilter: "*",
            StatusFilters: _this.statusFilters(),
            DragDropState: { SelectedTrade: undefined, CanAffirm: false, CanReject: false, CanClear: false, CanCompress: false }
        };
        return _this;
    }
    return TradeList;
}(React.Component));
export { TradeList };
//# sourceMappingURL=tradeList.js.map