import * as React from 'react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
export var TradeListItemRow = function (props) {
    return (React.createElement("tr", { key: props.trade.cdmContract.contractIdentifier[0].identifierValue.identifier, draggable: true, onDragStart: function (e) { return props.dragStartHandler(e, props.trade); }, onDragEnd: function (e) { return props.dragEndHandler(e); }, className: (props.trade.highlight) ? "flashingTradeListRow" : "" },
        React.createElement("td", null,
            React.createElement("div", null, props.trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference)),
        React.createElement("td", null,
            React.createElement("div", null, props.trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference)),
        React.createElement("td", null, props.trade.cdmContract.contractIdentifier[0].identifierValue.identifier),
        React.createElement("td", null, props.trade.contractStatus),
        React.createElement("td", null, props.trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency),
        React.createElement("td", null, props.trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.initialValue),
        React.createElement("td", null, props.trade.cdmContract.tradeDate.adjustableDate.unadjustedDate),
        React.createElement("td", null, props.trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].calculationPeriodDates.effectiveDate.adjustableDate.unadjustedDate),
        React.createElement("td", null, props.trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].calculationPeriodDates.calculationPeriodFrequency.period),
        React.createElement("td", null, props.trade.cdmContract.contractualProduct.productIdentification.primaryAssetClass),
        React.createElement("td", { align: "center" },
            React.createElement("button", { type: "button", title: "Show trade lineage.", className: "btn btn-info", "data-toggle": "modal", "data-target": "#exampleModal", onClick: function () { return props.selectForLineageHandler(props.currentMember, props.trade); } },
                React.createElement(FontAwesomeIcon, { icon: "file-alt" })))));
};
//# sourceMappingURL=tradeListItemRow.js.map