var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from "react";
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
var TradesReset = /** @class */ (function (_super) {
    __extends(TradesReset, _super);
    function TradesReset(props) {
        var _this = _super.call(this, props) || this;
        _this.render = function () {
            return (React.createElement("div", null,
                React.createElement("h1", null, "Trade Reset"),
                React.createElement("table", { className: "table table-striped table-hover" },
                    React.createElement("thead", null,
                        React.createElement("tr", null,
                            React.createElement("th", null, "Reset Date"),
                            React.createElement("th", null))),
                    React.createElement("tbody", null,
                        React.createElement("tr", null,
                            React.createElement("td", null,
                                React.createElement("input", { type: "date", name: "resetDate", min: "2018-10-01", onChange: _this.dateChanged })),
                            React.createElement("td", null,
                                React.createElement("button", { type: "button", title: "Reset Trade(s).", disabled: !_this.state, className: "btn btn-info", onClick: function () { return _this.props.actionResetHandler(_this.props.originator.host.hostIP, _this.props.originator.host.hostPort, _this.state.selectedDate); } },
                                    React.createElement(FontAwesomeIcon, { icon: "sign-in-alt" })))))),
                React.createElement("hr", null),
                React.createElement("h1", null, "Payments"),
                React.createElement("table", { className: "table table-striped table-hover" },
                    React.createElement("thead", null,
                        React.createElement("tr", null,
                            React.createElement("th", null, "Trade ID"),
                            React.createElement("th", null, "Payer"),
                            React.createElement("th", null, "Receiver"),
                            React.createElement("th", null, "Amount"),
                            React.createElement("th", null, "Currency"),
                            React.createElement("th", null, "Date"),
                            React.createElement("th", null, "Reset Value"))),
                    React.createElement("tbody", null, _this.props.payments.map(function (cfe) {
                        return React.createElement("tr", { key: cfe.rosettaKey },
                            React.createElement("td", null, cfe.contractId),
                            React.createElement("td", null, cfe.cashflow.payerReceiver.payerPartyReference),
                            React.createElement("td", null, cfe.cashflow.payerReceiver.receiverPartyReference),
                            React.createElement("td", null, cfe.cashflow.cashflowAmount.amount),
                            React.createElement("td", null, cfe.cashflow.cashflowAmount.currency),
                            React.createElement("td", null, cfe.date),
                            React.createElement("td", null, cfe.resetValue));
                    })))));
        };
        _this.dateChanged = function (event) { console.log("Reset Date changed to " + event.target.value); _this.setState({ selectedDate: event.target.value }); };
        return _this;
    }
    return TradesReset;
}(React.Component));
export { TradesReset };
/*

{
        "cashflow": {
            "payerReceiver": {
                "payerPartyReference": "DEALER-D01",
                "receiverPartyReference": "DEALER-D02"
            },
            "cashflowAmount": {
                "amount": 554030.1369863014034210409175518208257926744408905506134033203125,
                "currency": "USD"
            },
            "cashflowCalculation": "FloatingAmount",
            "rosettaKeyValue": "b1e295ab"
        },
        "date": "2019-02-16",
        "resetValue": 1.12345,
        "rosettaKey": "4e5e908c"
    }

*/
//# sourceMappingURL=tradesReset.js.map