import { connect } from 'react-redux';
import { TradeList, TradeListContextEnum } from '../components/tradeList';
import { SelectTradeForApprove, SelectTradeForCompression, SelectTradeForClearing, CompressTrades, ApproveTrades, ClearingTrades, SelectTradeForShowingLineage, SelectTradeForReject, RejectTrades } from '../actions/tradeList';
var mapStateToProps = function (state) { return ({
    context: state.CurrentMember.state.data.membershipMetadata.role.toUpperCase() === "REGULATOR" ? TradeListContextEnum.RO : TradeListContextEnum.RW,
    currentMember: state.CurrentMember,
    trades: state.AllTrades
}); };
var mapDispatchToProps = function (dispatch) { return ({
    actionApproveHandler: function (bno) { return dispatch(ApproveTrades(bno)); },
    actionClearHandler: function (bno) { return dispatch(ClearingTrades(bno)); },
    actionCompressHandler: function (bno) { return dispatch(CompressTrades(bno)); },
    actionRejectHandler: function (bno) { return dispatch(RejectTrades(bno)); },
    selectForApproveHandler: function (t) { return dispatch(SelectTradeForApprove(t)); },
    selectForClearingHandler: function (t) { return dispatch(SelectTradeForClearing(t)); },
    selectForCompressHandler: function (t) { return dispatch(SelectTradeForCompression(t)); },
    selectForLineageHandler: function (bno, t) { return dispatch(SelectTradeForShowingLineage(bno, t)); },
    selectForRejectHandler: function (t) { return dispatch(SelectTradeForReject(t)); },
}); };
var TradeListContainer = connect(mapStateToProps, mapDispatchToProps)(TradeList);
export default TradeListContainer;
//# sourceMappingURL=tradeList.js.map