export var TradeEligibleForCompression = function (trade, alreadySelectedTrades) {
    if (alreadySelectedTrades.length === 0) {
        return trade.contractStatus === "LIVE";
    }
    else {
        return alreadySelectedTrades.every(function (t) {
            return t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency ===
                trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].quantity.notionalSchedule.notionalStepSchedule.currency &&
                t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference ===
                    trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference &&
                t.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference ===
                    trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference;
        }) &&
            trade.contractStatus === "LIVE";
    }
};
export var TradeEligibleForClearing = function (trade) {
    return trade.contractStatus === "LIVE" &&
        trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.payerPartyReference !== "CCP-P01" &&
        trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference !== "CCP-P01";
};
export var TradeEligibleForAffirmation = function (trade, currentMember) {
    return trade.contractStatus === "DRAFT" && trade.cdmContract.contractualProduct.economicTerms.payout.interestRatePayout[0].payerReceiver.receiverPartyReference === currentMember.state.data.membershipMetadata.partyId;
};
export var TradeEligibleForRejection = function (trade, currentMember) {
    return trade.contractStatus === "DRAFT";
};
//# sourceMappingURL=model.js.map