var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as Actions from '../actions/tradeList';
import { RequestCompressActiveContracts, RequestApproveDraftCDMContract, RequestClearCDMContract, GetTradesLineage, RequestRejectDraftCDMContract } from '../domain/rpc';
var intitialState = [];
var AllTrades = function (state, action) {
    if (state === void 0) { state = intitialState; }
    switch (action.type) {
        case Actions.CLEAR_TRADES_ACTION:
            return intitialState;
        case Actions.RPC_NEW_TRADE_ACTION:
        case Actions.RT_NEW_TRADE_ACTION:
            console.log("New Trade. " + action.type);
            var incomingTradeId_1 = (action.trade ? action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier : "");
            var incomingTradeStatus_1 = (action.trade ? action.trade.contractStatus : "");
            var exists = state.find(function (x) {
                return x.cdmContract.contractIdentifier[0].identifierValue.identifier === incomingTradeId_1 &&
                    x.contractStatus === incomingTradeStatus_1;
            });
            if (exists) {
                return state;
            }
            var showLineageSelectedContract1 = state.find(function (x) {
                return x.cdmContract.contractIdentifier[0].identifierValue.identifier === incomingTradeId_1 &&
                    x.contractStatus !== incomingTradeStatus_1 &&
                    x.selectedForLineage;
            });
            var addState = void 0;
            if (showLineageSelectedContract1) {
                addState = state.map(function (t) {
                    return (t.cdmContract.contractIdentifier[0].identifierValue.identifier === incomingTradeId_1) ? __assign({}, t, { highlight: (action.type === Actions.RT_NEW_TRADE_ACTION), contractStatus: incomingTradeStatus_1 }) : t;
                });
                addState.sort(function (a, b) { return ((a.cdmContract.contractIdentifier[0].identifierValue.identifier < b.cdmContract.contractIdentifier[0].identifierValue.identifier) ? -1 : (a.cdmContract.contractIdentifier[0].identifierValue.identifier > b.cdmContract.contractIdentifier[0].identifierValue.identifier) ? 1 : 0); });
                return addState;
            }
            addState = state.concat([__assign({}, action.trade, { highlight: (action.type === Actions.RT_NEW_TRADE_ACTION) })]);
            addState.sort(function (a, b) { return ((a.cdmContract.contractIdentifier[0].identifierValue.identifier < b.cdmContract.contractIdentifier[0].identifierValue.identifier) ? -1 : (a.cdmContract.contractIdentifier[0].identifierValue.identifier > b.cdmContract.contractIdentifier[0].identifierValue.identifier) ? 1 : 0); });
            return addState;
        case Actions.DELETE_TRADE_ACTION:
            var showLineageSelectedContract2 = state.find(function (x) {
                return x.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier &&
                    x.selectedForLineage;
            });
            if (showLineageSelectedContract2) {
                return state;
            }
            var deleteState = state.filter(function (t) { return action.trade && t.cdmContract.contractIdentifier[0].identifierValue.identifier !== action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier; });
            deleteState.sort(function (a, b) { return ((a.cdmContract.contractIdentifier[0].identifierValue.identifier < b.cdmContract.contractIdentifier[0].identifierValue.identifier) ? -1 : (a.cdmContract.contractIdentifier[0].identifierValue.identifier > b.cdmContract.contractIdentifier[0].identifierValue.identifier) ? 1 : 0); });
            return deleteState;
        case Actions.UPDATE_TRADE_ACTION:
            var showLineageSelectedContract3 = state.find(function (x) {
                return action.trade &&
                    x.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier &&
                    x.selectedForLineage;
            });
            var updateState = void 0;
            if (showLineageSelectedContract3) {
                updateState = state.map(function (t) {
                    return (t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { highlight: true }) : t;
                });
                return updateState;
            }
            updateState = state.map(function (c) {
                return (action.trade && c.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier)
                    ? __assign({}, action.trade, { highlight: true }) : c;
            });
            return updateState;
        case Actions.CLEAR_TRADE_HIGHLIGHT_ACTION:
            var showLineageSelectedContract4 = state.find(function (x) {
                return action.trade &&
                    x.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier &&
                    x.selectedForLineage;
            });
            var clearHighlightState = void 0;
            if (showLineageSelectedContract4) {
                clearHighlightState = state.map(function (t) {
                    return (t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { highlight: false }) : t;
                });
                return clearHighlightState;
            }
            clearHighlightState = state.map(function (c) {
                return (action.trade && c.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier)
                    ? __assign({}, action.trade, { highlight: false }) : c;
            });
            return clearHighlightState;
        case Actions.TOGGLE_FOR_COMPRESSION_TRADES_ACTION:
            return state.map(function (t) {
                return (action.trade && t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { selectedForCompress: !t.selectedForCompress }) : t;
            });
        case Actions.COMPRESS_TRADES_ACTION:
            if (action.host && action.port) {
                console.log("Compress " + state.filter(function (t) { return t.selectedForCompress; }).length + " Trades.");
                var submitData = state.filter(function (t) { return t.selectedForCompress; }).map(function (t) {
                    return t.cdmContract.contractIdentifier[0].identifierValue.identifier;
                });
                console.log(submitData);
                RequestCompressActiveContracts(action.host, action.port, submitData);
            }
            return state;
        case Actions.TOGGLE_FOR_APPROVE_TRADES_ACTION:
            return state.map(function (t) {
                return (action.trade && t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { selectedForApprove: !t.selectedForApprove }) : t;
            });
        case Actions.APPROVE_TRADES_ACTION:
            if (action.host && action.port) {
                console.log("Approve " + state.filter(function (t) { return t.selectedForApprove; }).length + " Trades.");
                var submitData = state.filter(function (t) { return t.selectedForApprove; }).map(function (t) {
                    return t.cdmContract.contractIdentifier[0].identifierValue.identifier;
                });
                console.log(submitData);
                RequestApproveDraftCDMContract(action.host, action.port, submitData);
            }
            return state;
        case Actions.TOGGLE_FOR_REJECT_TRADES_ACTION:
            return state.map(function (t) {
                return (action.trade && t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { selectedForReject: !t.selectedForReject }) : t;
            });
        case Actions.REJECT_TRADES_ACTION:
            if (action.host && action.port) {
                console.log("Approve " + state.filter(function (t) { return t.selectedForReject; }).length + " Trades.");
                var submitData = state.filter(function (t) { return t.selectedForReject; }).map(function (t) {
                    return t.cdmContract.contractIdentifier[0].identifierValue.identifier;
                });
                console.log(submitData);
                RequestRejectDraftCDMContract(action.host, action.port, submitData);
            }
            return state;
        case Actions.TOGGLE_FOR_CLEARING_TRADES_ACTION:
            return state.map(function (t) {
                return (action.trade && t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { selectedForClearing: !t.selectedForClearing }) : t;
            });
        case Actions.CLEARING_TRADES_ACTION:
            if (action.host && action.port) {
                console.log("Clear " + state.filter(function (t) { return t.selectedForClearing; }).length + " Trades.");
                var submitData = state.filter(function (t) { return t.selectedForClearing; }).map(function (t) {
                    return t.cdmContract.contractIdentifier[0].identifierValue.identifier;
                });
                console.log(submitData);
                RequestClearCDMContract(action.host, action.port, submitData);
            }
            return state;
        case Actions.TOGGLE_FOR_SHOWING_LINEAGE_ACTION:
            if (action.host && action.port && action.trade && !action.trade.selectedForLineage) {
                var lineageList_1 = GetTradesLineage(action.host, action.port, action.trade);
                state = state.map(function (t) {
                    return (t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { cdmContractsLineage: (lineageList_1 ? lineageList_1 : []), selectedForLineage: true }) : t;
                });
                return state;
            }
            else if (action.host && action.port && action.trade && action.trade.selectedForLineage) {
                state = state.map(function (t) {
                    return (t.cdmContract.contractIdentifier[0].identifierValue.identifier === action.trade.cdmContract.contractIdentifier[0].identifierValue.identifier) ? __assign({}, t, { cdmContractsLineage: [], selectedForLineage: false }) : t;
                });
                return state;
            }
            return state;
        default:
            return state;
    }
};
export default AllTrades;
//# sourceMappingURL=tradeList.js.map